/*!
 * \file  glut_example.cxx
 * \brief 
 *
 * \author Stefan Brabec <brabec@mpi-sb.mpg.de>
 * \date 10/29/1999
 * 
 *   (c)1999 Max-Planck-Institute for Computer Science
 *           Computer Graphics Group, AG4
 *           http://www.mpi-sb.mpg.de
 *   All Rights Reserved.
 *
 *---------------------------------------------------------------------
 $Id: glut_example.cxx,v 1.1 2000/08/02 13:04:26 web-tmk Exp $
 *---------------------------------------------------------------------
 $Log: glut_example.cxx,v $
 Revision 1.1  2000/08/02 13:04:26  web-tmk
 added glut demo

 *---------------------------------------------------------------------*/
#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include <GL/glut.h>

static float rotator = 0.0;
static int   mainWin = 0;

void display();
void idle();
void keyboard(unsigned  char selection, int x, int y);

int main(int argc,char** argv)
{
  glutInitDisplayMode(GLUT_DEPTH|GLUT_RGBA|GLUT_DOUBLE|GLUT_ALPHA);
  glutInitWindowPosition( 0, 0 );
  glutInitWindowSize(512, 512);
  if(argc != 0 && argv != NULL)
    glutInit(&argc, argv);
  mainWin = glutCreateWindow("GLUT");

  glutDisplayFunc( display );
  glutIdleFunc( idle );
  glutKeyboardFunc( keyboard );

  glClearColor(0,0,0,0);
  glDisable(GL_DITHER);
  glEnable(GL_DEPTH_TEST);
  glShadeModel(GL_SMOOTH);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(50.0,1.0,0.01,200.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glViewport(0,0,512,512);

  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  static float light_pos[] = { 0,0,-8,0 };
  glLightfv(GL_LIGHT0, GL_POSITION, (float*)light_pos);
  glLightModelf(GL_LIGHT_MODEL_TWO_SIDE ,GL_TRUE);
  glDisable(GL_CULL_FACE);
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_NORMALIZE);
  glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
  glutMainLoop();
}  

void idle()
{
  rotator += 1.0;
  if(rotator >= 360.0)
    rotator = 0.0;
  glutSetWindow(mainWin);
  glutPostRedisplay();
}

void reshape(int w,int h)
{
  glViewport(0,0,w,h);
}


void display()
{
  GLfloat white_color[] = { 1.0,1.0,1.0,0.0 };

  glClearColor(0,0,0,0);
  glClear(GL_DEPTH_BUFFER_BIT|GL_COLOR_BUFFER_BIT);
  {
    glPushMatrix();
    glTranslatef(0,0,-6);
    glColor3f(0.9,0.1,0.2);
    
    glRotatef(rotator,1,0,0);
    glRotatef(rotator,0,1,0);
    glRotatef(rotator,0,0,1);
    GLfloat red_color[] =  { rotator / 360.0,
			     1.0 - (rotator / 360.0),
			     rotator / 360.0, 0.0 };
    glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,red_color);
    glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,white_color);
    glutSolidTeapot(1.4);
    glPopMatrix();
  }
  glutSwapBuffers();
}

void keyboard(unsigned  char selection, int x, int y)
{
  x=x;y=y;
  switch(selection)
  {
    case 'q':
      exit(0);
      break;
    default:
      break;
  }
}

